//  Copyright 2005-2010 Jason Aaron Osgood, Jean-Francois Poilpret
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package net.java.dev.designgridlayout.showdown;

import java.awt.Component;
import java.awt.Font;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;

class NodeRenderer extends DefaultTreeCellRenderer
{
	public NodeRenderer()
	{
		setClosedIcon(getDefaultLeafIcon());
		setOpenIcon(getDefaultLeafIcon());
	}

	@Override public Component getTreeCellRendererComponent(
		JTree tree, Object value, boolean sel, boolean expanded, boolean leaf, int row,
		boolean isFocused)
	{
		super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf, row, isFocused);
		DefaultMutableTreeNode node = (DefaultMutableTreeNode) value;
		int style = Font.BOLD;
		if (node.getUserObject() instanceof Node)
		{
			Node realNode = (Node) node.getUserObject();
			if (realNode.isLaunchable())
			{
				style = Font.PLAIN;
			}
		}
		setFont(getFont().deriveFont(style));
		return this;
	}
}
